int N=int.Parse(Console.ReadLine());
int M=int.Parse(Console.ReadLine());
int U=0;
int a=0;
for(int i=0; i<N; i++)
{
    for(int j=0; j<M; j++)
    {
        a++;
        Console.Write(a+" ");
    }
    Console.WriteLine("");
}
int Q=int.Parse(Console.ReadLine());
for(int k=1;k<=Q;k++)
{
    int i1=int.Parse(Console.ReadLine());
    int j1=int.Parse(Console.ReadLine());
    if(i1>1 && j1 != M)
    {
        for(int x=1; x<M; x++)
        {
            U=U+x;
        }
        for(int x=1; x<N; x++)
        {
            U=U+x*M;
        }
    }
    else if(i1==1 && j1 != M)
    {
        if(j1<=M-4)
        {
            for(int x=1; x<j1; x++)
            {
                U=U+x;
            }
            for(int x=j1-1; x<=j1+1; x++)
            {
                U=U+M+x;
            }
            for(int x=j1+1; x<M; x++)
            {
                U=U+x;
            }
            for(int x=1; x<=N; x++)
            {
                U=U+x*M;
            }
        }
        else
        {
            for(int x=1; x<j1; x++)
            {
                U=U+x;
            }
            for(int x=j1-1; x<M; x++)
            {
                U=U+M+x;
            }
            for(int x=2; x<=N; x++)
            {
                U=U+x*M;
            }
        }
    }
    else
    {
        for(int x=1; x<M; x++)
        {
            U=U+x;
        }
        for(int x=2; x<=i1+1; x++)
        {
            U=U+x*M-1;
        }
        for(int x=i1+1; x<=N; x++)
        {
            U=U+x*M;
        }
    }
    Console.WriteLine(U);
    U=0;
}